/*
 * ValidarDiscapacidadDep.java
 *
 * Created on 9 de abril de 2007, 08:51 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.Date;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Jsolano
 */
public class ValidarDiscapacidadDep extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	/** Creates a new instance of CampoLlenoParaUnValorDiferenteDeOtroCampo */

	public ValidarDiscapacidadDep() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	// 9,N07,8,'B',13,'2',14  11,N07,8,B,15,2,16,12
	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (!codigoNovedad.equals((String) getParams()[1])) {
			return false;
		}

		String fechaNacimiento = registro[new Integer((String) getParams()[2])
				.intValue()];
		String columnaTipoAfiliado = registro[new Integer(
				(String) getParams()[4]).intValue()];
		String columnaParentesco = registro[new Integer((String) getParams()[6])
				.intValue()];
		String tipoAfiliado = (String) getParams()[3];
		String parentesco = (String) getParams()[5];

		if (!ValidarFecha.esFecha(fechaNacimiento))
			return false;

		Date dtFechaNacimiento;

		try {
			dtFechaNacimiento = sdf.parse(fechaNacimiento);
		} catch (Exception e) {
			return false;
		}

		// EACG.30/03/2009.INI.A19115.Ajustes Malla Validadora, Fecha Nacimiento
		// contra Fecha Novedad
		String FechaNovedad = registro[new Integer((String) getParams()[4])
				.intValue()];
		if (!ValidarFecha.esFecha(FechaNovedad))
			return false;
		Date dateFechaNovedad = null;
		try {
			dateFechaNovedad = sdf.parse(FechaNovedad);
		} catch (Exception e) {
			return false;
		}
		// long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
		// Calendar.getInstance().getTime());
		long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
				dateFechaNovedad);
		// EACG.30/03/2009.FIN.A19115.

		;
		long annos = edadDias / 365;
              
		if (columnaTipoAfiliado.equals(tipoAfiliado)
				&& parentesco.equals(columnaParentesco)) {
			if (annos >= 18 && annos <= 25 && field.equals("E"))
                            
                            
				return false; 
			if (annos >= 18 && field.equals("D"))
				return false; 

			if (annos < 18 && field.length() == 0)
				return false; 
			return true;  
		}

		if (field.length() > 0)
			return true;

		return false;

	}

}
